
namespace iup_mglplot

include std/dll.e
include std/machine.e

atom iup_mglplot = open_dll({ "iup_mglplot.dll", "libiup_mglplot.so", "libiup_mglplot.dylib" })


constant -- function delcarations
	xIupMglPlotOpen                   = define_c_proc( iup_mglplot, "+IupMglPlotOpen", {} ),
	xIupMglPlot                       = define_c_func( iup_mglplot, "+IupMglPlot", {}, C_POINTER ),
	xIupMglPlotBegin                  = define_c_proc( iup_mglplot, "+IupMglPlotBegin", {C_POINTER,C_INT} ),
	xIupMglPlotAdd1D                  = define_c_proc( iup_mglplot, "+IupMglPlotAdd1D", {C_POINTER,C_POINTER,C_DOUBLE} ),
	xIupMglPlotAdd2D                  = define_c_proc( iup_mglplot, "+IupMglPlotAdd2D", {C_POINTER,C_DOUBLE,C_DOUBLE} ),
	xIupMglPlotAdd3D                  = define_c_proc( iup_mglplot, "+IupMglPlotAdd3D", {C_POINTER,C_DOUBLE,C_DOUBLE,C_DOUBLE} ),
	xIupMglPlotEnd                    = define_c_func( iup_mglplot, "+IupMglPlotEnd", {C_POINTER}, C_INT ),
	xIupMglPlotNewDataSet             = define_c_func( iup_mglplot, "+IupMglPlotNewDataSet", {C_POINTER,C_INT}, C_INT ),
	xIupMglPlotInsert1D               = define_c_proc( iup_mglplot, "+IupMglPlotInsert1D", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupMglPlotInsert2D               = define_c_proc( iup_mglplot, "+IupMglPlotInsert2D", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupMglPlotInsert3D               = define_c_proc( iup_mglplot, "+IupMglPlotInsert3D", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_POINTER,C_INT} ),
	xIupMglPlotSet1D                  = define_c_proc( iup_mglplot, "+IupMglPlotSet1D", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupMglPlotSet2D                  = define_c_proc( iup_mglplot, "+IupMglPlotSet2D", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupMglPlotSet3D                  = define_c_proc( iup_mglplot, "+IupMglPlotSet3D", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_POINTER,C_INT} ),
	xIupMglPlotSetFormula             = define_c_proc( iup_mglplot, "+IupMglPlotSetFormula", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_POINTER,C_INT} ),
	xIupMglPlotSetData                = define_c_proc( iup_mglplot, "+IupMglPlotSetData", {C_POINTER,C_INT,C_POINTER,C_INT,C_INT,C_INT} ),
	xIupMglPlotLoadData               = define_c_proc( iup_mglplot, "+IupMglPlotLoadData", {C_POINTER,C_INT,C_POINTER,C_INT,C_INT,C_INT} ),
	xIupMglPlotSetFromFormula         = define_c_proc( iup_mglplot, "+IupMglPlotSetFromFormula", {C_POINTER,C_INT,C_POINTER,C_INT,C_INT,C_INT} ),
	xIupMglPlotTransform              = define_c_proc( iup_mglplot, "+IupMglPlotTransform", {C_POINTER,C_DOUBLE,C_DOUBLE,C_DOUBLE,C_POINTER,C_POINTER} ),
	xIupMglPlotTransformTo            = define_c_proc( iup_mglplot, "+IupMglPlotTransformTo", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_POINTER} ),
	xIupMglPlotDrawMark               = define_c_proc( iup_mglplot, "+IupMglPlotDrawMark", {C_POINTER,C_DOUBLE,C_DOUBLE,C_DOUBLE} ),
	xIupMglPlotDrawLine               = define_c_proc( iup_mglplot, "+IupMglPlotDrawLine", {C_POINTER,C_DOUBLE,C_DOUBLE,C_DOUBLE,C_DOUBLE,C_DOUBLE,C_DOUBLE} ),
	xIupMglPlotDrawText               = define_c_proc( iup_mglplot, "+IupMglPlotDrawText", {C_POINTER,C_POINTER,C_DOUBLE,C_DOUBLE,C_DOUBLE} ),
	xIupMglPlotPaintTo                = define_c_proc( iup_mglplot, "+IupMglPlotPaintTo", {C_POINTER,C_POINTER,C_INT,C_INT,C_DOUBLE,C_POINTER} ),
	xIupMglLabel                      = define_c_func( iup_mglplot, "+IupMglLabel", {C_POINTER}, C_POINTER ),
$

/* Initialize IupMglPlot widget class */
--void IupMglPlotOpen(void);
public procedure IupMglPlotOpen()
	c_proc( xIupMglPlotOpen, {} )
end procedure

/* Create an IupMglPlot widget instance */
--Ihandle* IupMglPlot(void);
public function IupMglPlot()
	atom result = c_func( xIupMglPlot, {} )
	return result
end function

/***********************************************/
/*           Additional API                    */
/* Linear Data Only */
--void IupMglPlotBegin(Ihandle *ih, int dim);
public procedure IupMglPlotBegin(atom ih, atom dim)
	c_proc( xIupMglPlotBegin, {ih,dim} )
end procedure

--void IupMglPlotAdd1D(Ihandle *ih, const char* name, double y);
public procedure IupMglPlotAdd1D(atom ih, object name = NULL, atom y)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupMglPlotAdd1D, {ih,name,y} )
end procedure

--void IupMglPlotAdd2D(Ihandle *ih, double x, double y);
public procedure IupMglPlotAdd2D(atom ih, atom x, atom y)
	c_proc( xIupMglPlotAdd2D, {ih,x,y} )
end procedure

--void IupMglPlotAdd3D(Ihandle *ih, double x, double y, double z);
public procedure IupMglPlotAdd3D(atom ih, atom x, atom y, atom z)
	c_proc( xIupMglPlotAdd3D, {ih,x,y,z} )
end procedure

--int IupMglPlotEnd(Ihandle *ih);
public function IupMglPlotEnd(atom ih)
	atom result = c_func( xIupMglPlotEnd, {ih} )
	return result
end function

/* Linear (dim=1,2,3), Planar (dim=1), Volumetric (dim=1) */
--int IupMglPlotNewDataSet(Ihandle *ih, int dim);
public function IupMglPlotNewDataSet(atom ih, atom dim)
	atom result = c_func( xIupMglPlotNewDataSet, {ih,dim} )
	return result
end function

/* Linear Data Only */
--void IupMglPlotInsert1D(Ihandle* ih, int ds_index, int sample_index, const char** names, const double* y, int count);
public procedure IupMglPlotInsert1D(atom ih, atom ds_index, atom sample_index, sequence names = {}, atom y, atom count)
	atom p_names = allocate_string_pointer_array(names)
	c_proc( xIupMglPlotInsert1D, {ih,ds_index,sample_index,p_names,y,count} )
	free(p_names)
end procedure

--void IupMglPlotInsert2D(Ihandle* ih, int ds_index, int sample_index, const double* x, const double* y, int count);
public procedure IupMglPlotInsert2D(atom ih, atom ds_index, atom sample_index, atom x, atom y, atom count)
	c_proc( xIupMglPlotInsert2D, {ih,ds_index,sample_index,x,y,count} )
end procedure

--void IupMglPlotInsert3D(Ihandle* ih, int ds_index, int sample_index, const double* x, const double* y, const double* z, int count);
public procedure IupMglPlotInsert3D(atom ih, atom ds_index, atom sample_index, atom x, atom y, atom z, atom count)
	c_proc( xIupMglPlotInsert3D, {ih,ds_index,sample_index,x,y,z,count} )
end procedure

/* Linear Data Only */
--void IupMglPlotSet1D(Ihandle* ih, int ds_index, const char** names, const double* y, int count);
public procedure IupMglPlotSet1D(atom ih, atom ds_index, sequence names = {}, atom y, atom count)
	atom p_names = allocate_string_pointer_array(names)
	c_proc( xIupMglPlotSet1D, {ih,ds_index,p_names,y,count} )
	free(p_names)
end procedure

--void IupMglPlotSet2D(Ihandle* ih, int ds_index, const double* x, const double* y, int count);
public procedure IupMglPlotSet2D(atom ih, atom ds_index, atom x, atom y, atom count)
	c_proc( xIupMglPlotSet2D, {ih,ds_index,x,y,count} )
end procedure

--void IupMglPlotSet3D(Ihandle* ih, int ds_index, const double* x, const double* y, const double* z, int count);
public procedure IupMglPlotSet3D(atom ih, atom ds_index, atom x, atom y, atom z, atom count)
	c_proc( xIupMglPlotSet3D, {ih,ds_index,x,y,z,count} )
end procedure

--void IupMglPlotSetFormula(Ihandle* ih, int ds_index, const char* formulaX, const char* formulaY, const char* formulaZ, int count);
public procedure IupMglPlotSetFormula(atom ih, atom ds_index, object formulaX = NULL, object formulaY = NULL, object formulaZ = NULL, atom count)
	if sequence(formulaX) then formulaX = allocate_string(formulaX) end if
	if sequence(formulaY) then formulaY = allocate_string(formulaY) end if
	if sequence(formulaZ) then formulaZ = allocate_string(formulaZ) end if
	c_proc( xIupMglPlotSetFormula, {ih,ds_index,formulaX,formulaY,formulaZ,count} )
end procedure

/* Linear (dim=1), Planar (dim=1), Volumetric (dim=1) */
--void IupMglPlotSetData(Ihandle* ih, int ds_index, const double* data, int count_x, int count_y, int count_z);
public procedure IupMglPlotSetData(atom ih, atom ds_index, atom data, atom count_x, atom count_y, atom count_z)
	c_proc( xIupMglPlotSetData, {ih,ds_index,data,count_x,count_y,count_z} )
end procedure

--void IupMglPlotLoadData(Ihandle* ih, int ds_index, const char* filename, int count_x, int count_y, int count_z);
public procedure IupMglPlotLoadData(atom ih, atom ds_index, object filename = NULL, atom count_x, atom count_y, atom count_z)
	if sequence(filename) then filename = allocate_string(filename) end if
	c_proc( xIupMglPlotLoadData, {ih,ds_index,filename,count_x,count_y,count_z} )
end procedure

--void IupMglPlotSetFromFormula(Ihandle* ih, int ds_index, const char* formula, int count_x, int count_y, int count_z);
public procedure IupMglPlotSetFromFormula(atom ih, atom ds_index, object formula = NULL, atom count_x, atom count_y, atom count_z)
	if sequence(formula) then formula = allocate_string(formula) end if
	c_proc( xIupMglPlotSetFromFormula, {ih,ds_index,formula,count_x,count_y,count_z} )
end procedure

/* Only inside callbacks */
--void IupMglPlotTransform(Ihandle* ih, double x, double y, double z, int *ix, int *iy);
public procedure IupMglPlotTransform(atom ih, atom x, atom y, atom z, atom ix, atom iy)
	c_proc( xIupMglPlotTransform, {ih,x,y,z,ix,iy} )
end procedure

--void IupMglPlotTransformTo(Ihandle* ih, int ix, int iy, double *x, double *y, double *z);
public procedure IupMglPlotTransformTo(atom ih, atom ix, atom iy, atom x, atom y, atom z)
	c_proc( xIupMglPlotTransformTo, {ih,ix,iy,x,y,z} )
end procedure

/* Only inside callbacks */
--void IupMglPlotDrawMark(Ihandle* ih, double x, double y, double z);
public procedure IupMglPlotDrawMark(atom ih, atom x, atom y, atom z)
	c_proc( xIupMglPlotDrawMark, {ih,x,y,z} )
end procedure

--void IupMglPlotDrawLine(Ihandle* ih, double x1, double y1, double z1, double x2, double y2, double z2);
public procedure IupMglPlotDrawLine(atom ih, atom x1, atom y1, atom z1, atom x2, atom y2, atom z2)
	c_proc( xIupMglPlotDrawLine, {ih,x1,y1,z1,x2,y2,z2} )
end procedure

--void IupMglPlotDrawText(Ihandle* ih, const char* text, double x, double y, double z);
public procedure IupMglPlotDrawText(atom ih, object text = NULL, atom x, atom y, atom z)
	if sequence(text) then text = allocate_string(text) end if
	c_proc( xIupMglPlotDrawText, {ih,text,x,y,z} )
end procedure

--void IupMglPlotPaintTo(Ihandle *ih, const char* format, int w, int h, double dpi, void *data);
public procedure IupMglPlotPaintTo(atom ih, object format = NULL, atom w, atom h, atom dpi, atom data)
	if sequence(format) then format = allocate_string(format) end if
	c_proc( xIupMglPlotPaintTo, {ih,format,w,h,dpi,data} )
end procedure

/***********************************************/
/* Utility label for showing TeX labels */
--Ihandle* IupMglLabel(const char* title);
public function IupMglLabel(object title = NULL)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupMglLabel, {title} )
	return result
end function


