
namespace iupmask

include std/dll.e
include std/machine.e

atom iupcontrols = open_dll({ "iupcontrols.dll", "libiupcontrols.so", "libiupcontrols.dylib" })


constant -- function delcarations
	xiupmaskSet                       = define_c_func( iupcontrols, "+iupmaskSet", {C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
	xiupmaskSetInt                    = define_c_func( iupcontrols, "+iupmaskSetInt", {C_POINTER,C_INT,C_INT  ,C_INT  }, C_INT ),
	xiupmaskSetFloat                  = define_c_func( iupcontrols, "+iupmaskSetFloat", {C_POINTER,C_INT,C_FLOAT,C_FLOAT}, C_INT ),
	xiupmaskRemove                    = define_c_proc( iupcontrols, "+iupmaskRemove", {C_POINTER} ),
	xiupmaskCheck                     = define_c_func( iupcontrols, "+iupmaskCheck", {C_POINTER}, C_INT ),
	xiupmaskGet                       = define_c_func( iupcontrols, "+iupmaskGet", {C_POINTER,C_POINTER}, C_INT ),
	xiupmaskGetFloat                  = define_c_func( iupcontrols, "+iupmaskGetFloat", {C_POINTER,C_POINTER}, C_INT ),
	xiupmaskGetDouble                 = define_c_func( iupcontrols, "+iupmaskGetDouble", {C_POINTER,C_POINTER}, C_INT ),
	xiupmaskGetInt                    = define_c_func( iupcontrols, "+iupmaskGetInt", {C_POINTER,C_POINTER}, C_INT ),
	xiupmaskMatSet                    = define_c_func( iupcontrols, "+iupmaskMatSet", {C_POINTER,C_POINTER,C_INT,C_INT,C_INT,C_INT}, C_INT ),
	xiupmaskMatSetInt                 = define_c_func( iupcontrols, "+iupmaskMatSetInt", {C_POINTER,C_INT,C_INT  ,C_INT  ,C_INT,C_INT}, C_INT ),
	xiupmaskMatSetFloat               = define_c_func( iupcontrols, "+iupmaskMatSetFloat", {C_POINTER,C_INT,C_FLOAT,C_FLOAT,C_INT,C_INT}, C_INT ),
	xiupmaskMatRemove                 = define_c_proc( iupcontrols, "+iupmaskMatRemove", {C_POINTER,C_INT,C_INT} ),
	xiupmaskMatCheck                  = define_c_func( iupcontrols, "+iupmaskMatCheck", {C_POINTER,C_INT,C_INT}, C_INT ),
	xiupmaskMatGet                    = define_c_func( iupcontrols, "+iupmaskMatGet", {C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
	xiupmaskMatGetFloat               = define_c_func( iupcontrols, "+iupmaskMatGetFloat", {C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
	xiupmaskMatGetDouble              = define_c_func( iupcontrols, "+iupmaskMatGetDouble", {C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
	xiupmaskMatGetInt                 = define_c_func( iupcontrols, "+iupmaskMatGetInt", {C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
$

/* DEPRECATED definitions, use the MASK attribute in IupText or IupMatrix. It will be removed in a future version. */
--int iupmaskSet(Ihandle *h, const char *mask, int autofill, int casei);
public function iupmaskSet(atom h, object mask = NULL, atom autofill, atom casei)
	if sequence(mask) then mask = allocate_string(mask) end if
	atom result = c_func( xiupmaskSet, {h,mask,autofill,casei} )
	return result
end function

--int iupmaskSetInt(Ihandle *h, int autofill, int min , int max);
public function iupmaskSetInt(atom h, atom autofill, atom min, atom max)
	atom result = c_func( xiupmaskSetInt, {h,autofill,min,max} )
	return result
end function

--int iupmaskSetFloat(Ihandle *h, int autofill, float min , float max);
public function iupmaskSetFloat(atom h, atom autofill, atom min, atom max)
	atom result = c_func( xiupmaskSetFloat, {h,autofill,min,max} )
	return result
end function

--void iupmaskRemove(Ihandle *h);
public procedure iupmaskRemove(atom h)
	c_proc( xiupmaskRemove, {h} )
end procedure

--int iupmaskCheck(Ihandle *h);
public function iupmaskCheck(atom h)
	atom result = c_func( xiupmaskCheck, {h} )
	return result
end function

--int iupmaskGet(Ihandle *h, char **val);
public function iupmaskGet(atom h, atom val)
	atom result = c_func( xiupmaskGet, {h,val} )
	return result
end function

--int iupmaskGetFloat(Ihandle *h, float *fval);
public function iupmaskGetFloat(atom h, atom fval)
	atom result = c_func( xiupmaskGetFloat, {h,fval} )
	return result
end function

--int iupmaskGetDouble(Ihandle *h, double *dval);
public function iupmaskGetDouble(atom h, atom dval)
	atom result = c_func( xiupmaskGetDouble, {h,dval} )
	return result
end function

--int iupmaskGetInt(Ihandle *h, int *ival);
public function iupmaskGetInt(atom h, atom ival)
	atom result = c_func( xiupmaskGetInt, {h,ival} )
	return result
end function

--int iupmaskMatSet(Ihandle *h, const char *mask, int autofill, int casei, int lin, int col);
public function iupmaskMatSet(atom h, object mask = NULL, atom autofill, atom casei, atom lin, atom col)
	if sequence(mask) then mask = allocate_string(mask) end if
	atom result = c_func( xiupmaskMatSet, {h,mask,autofill,casei,lin,col} )
	return result
end function

--int iupmaskMatSetInt(Ihandle *h, int autofill, int min, int max, int lin, int col);
public function iupmaskMatSetInt(atom h, atom autofill, atom min, atom max, atom lin, atom col)
	atom result = c_func( xiupmaskMatSetInt, {h,autofill,min,max,lin,col} )
	return result
end function

--int iupmaskMatSetFloat(Ihandle *h, int autofill, float min, float max, int lin, int col);
public function iupmaskMatSetFloat(atom h, atom autofill, atom min, atom max, atom lin, atom col)
	atom result = c_func( xiupmaskMatSetFloat, {h,autofill,min,max,lin,col} )
	return result
end function

--void iupmaskMatRemove(Ihandle *h, int lin, int col);
public procedure iupmaskMatRemove(atom h, atom lin, atom col)
	c_proc( xiupmaskMatRemove, {h,lin,col} )
end procedure

--int iupmaskMatCheck(Ihandle *h, int lin, int col);
public function iupmaskMatCheck(atom h, atom lin, atom col)
	atom result = c_func( xiupmaskMatCheck, {h,lin,col} )
	return result
end function

--int iupmaskMatGet(Ihandle *h, char **val, int lin, int col);
public function iupmaskMatGet(atom h, atom val, atom lin, atom col)
	atom result = c_func( xiupmaskMatGet, {h,val,lin,col} )
	return result
end function

--int iupmaskMatGetFloat(Ihandle *h, float *fval, int lin, int col);
public function iupmaskMatGetFloat(atom h, atom fval, atom lin, atom col)
	atom result = c_func( xiupmaskMatGetFloat, {h,fval,lin,col} )
	return result
end function

--int iupmaskMatGetDouble(Ihandle *h, double *dval, int lin, int col);
public function iupmaskMatGetDouble(atom h, atom dval, atom lin, atom col)
	atom result = c_func( xiupmaskMatGetDouble, {h,dval,lin,col} )
	return result
end function

--int iupmaskMatGetInt(Ihandle *h, int *ival, int lin, int col);
public function iupmaskMatGetInt(atom h, atom ival, atom lin, atom col)
	atom result = c_func( xiupmaskMatGetInt, {h,ival,lin,col} )
	return result
end function


